%define ver_major 0.7
%define _name bse
%define pcm_device /dev/dsp
%define midi_device /dev/snd/seq

Name: beast
Version: %ver_major.2
Release: alt4.svn20090420.M50.1
Packager: Eugeny A. Rostovtsev (REAL) <real@altlinux.org>

Summary: BEAST/BSE - the bedevilled audio system and the bedevilled sound engine
License: GPL/LGPL
Group: Sound
Url: http://beast.gtk.org

# svn co svn://svn.gnome.org/svn/beast/trunk beast
Source: %name-%version.tar.bz2

Requires: %name-common = %version-%release
Requires: lib%_name-drivers-alsa = %version-%release

BuildRequires(pre): rpm-build-compat
BuildPreReq: menu-devel python python-module-libxml2 doxygen libalsa-devel
BuildPreReq: desktop-file-utils shared-mime-info kernel-headers
BuildPreReq: dev libgtk+2-devel libmad-devel ImageMagick-tools
#BuildPreReq: gcc-c++ libtool_2.2
BuildPreReq: gcc-c++
BuildPreReq: gcc-fortran
BuildPreReq: libstdc++-devel
BuildPreReq: rpm-build-compat

# Automatically added by buildreq on Fri Jan 16 2009 (-bi)
BuildRequires: glibc-devel guile18-devel libgnomecanvas-devel libmad-devel
BuildRequires: libvorbis-devel perl-XML-Parser

%description
BEAST (the Bedevilled Audio System) is a GTK+/GNOME based front-end 
to BSE (the Bedevilled Sound Engine). BSE is a shared library that 
comes with the necessary framework to simulate audio synthesis 
(modular synthesis) in realtime and allow for song composition.

%package common
Summary: Architecture-independent data for Beast
Group: Sound
Requires: lib%_name = %version-%release
BuildArch: noarch

%description common
Architecture-independent data for Beast.

%package -n lib%_name
Summary: Shared libraries for BEAST
Group: System/Libraries

%description -n lib%_name
BEAST (the Bedevilled Audio System) is a GTK+/GNOME based front-end 
to BSE (the Bedevilled Sound Engine). BSE is a shared library that 
comes with the necessary framework to simulate audio synthesis 
(modular synthesis) in realtime and allow for song composition.

This package contains shared libraries needed to BEAST.

%package -n lib%_name-devel
Summary: Development files for libbse
Group: Development/C
Requires: lib%_name = %version-%release

%description -n lib%_name-devel
BSE is a shared library that comes with the necessary framework to
simulate audio synthesis  (modular synthesis) in realtime and allow for
song composition.

This package contains headers and development libraries for libbse.

%package -n lib%_name-devel-doc
Summary: Development documentation for libbse
Group: Development/C
BuildArch: noarch

%description -n lib%_name-devel-doc
BSE is a shared library that comes with the necessary framework to
simulate audio synthesis  (modular synthesis) in realtime and allow for
song composition.

This package contains development documentation for libbse.

%package -n lib%_name-drivers-alsa
Summary: Shared libraries of alsa BSE driver
Group: System/Libraries
Requires: lib%_name = %version-%release

%description -n lib%_name-drivers-alsa
BEAST (the Bedevilled Audio System) is a GTK+/GNOME based front-end 
to BSE (the Bedevilled Sound Engine). BSE is a shared library that 
comes with the necessary framework to simulate audio synthesis 
(modular synthesis) in realtime and allow for song composition.

This package contains shared libraries of alsa BSE driver.

%prep
%setup

%build
cat %_datadir/libtool/aclocal/libtool.m4 >>aclocal.m4
./autogen.sh --prefix=%prefix
%configure --disable-static \
  --enable-osspcm=%pcm_device \
  --enable-ossmidi=%midi_device \
	--with-doxer=yes \
	--with-gnu-ld
mkdir -p html
mkdir -p docs/html
%make

# make BSE driver for ALSA
TOPDIR=$PWD
export BSE_DRIVER_DIR="$TOPDIR/drivers"
pushd ./drivers/%{_name}-alsa
BSE_LIBS="-Wl,--export-dynamic -L$TOPDIR/bse/.libs -lbse -lvorbisfile"
BSE_LIBS="$BSE_LIBS -lvorbisenc -lvorbis -logg -lgobject-2.0 -lgmodule-2.0"
export BSE_LIBS="$BSE_LIBS -lglib-2.0 -lasound"
export BSE_CFLAGS="-I$TOPDIR -I%_includedir/glib-2.0 -I%_libdir/glib-2.0/include"
sed -i \
	"s|bsedriverinstalldir=.*|bsedriverinstalldir=$BSE_DRIVER_DIR|g" \
	configure.in
%autoreconf
sed -i -e 's/\-rpath.*driversdir)//g' Makefile.in
%configure --disable-static \
	--with-gnu-ld
DRIVERLIB=%{_name}pcmdevice-alsa
gcc -DHAVE_CONFIG_H -I%_includedir/glib-2.0 -I%_libdir/glib-2.0/include \
	$BSE_CFLAGS %optflags %optflags_shared -c -o $DRIVERLIB.o $DRIVERLIB.c
gcc -shared -o $DRIVERLIB.so $DRIVERLIB.o $BSE_LIBS
DRIVERLIB=%{_name}mididevice-alsa
gcc -DHAVE_CONFIG_H -I%_includedir/glib-2.0 -I%_libdir/glib-2.0/include \
	$BSE_CFLAGS %optflags %optflags_shared -c -o $DRIVERLIB.o $DRIVERLIB.c
gcc -shared -o $DRIVERLIB.so $DRIVERLIB.o $BSE_LIBS
popd

%install
%make_install DESTDIR=%buildroot install

# remove non-packaged files
rm -f %buildroot%_libdir/*.la
rm -f %buildroot%_libdir/bse/v%version/plugins/*.la

# install BSE driver for ALSA
mkdir -p %buildroot%_libdir/%_name/v%version/drivers
install -m644 drivers/%{_name}-alsa/%{_name}*device-alsa.so \
	%buildroot%_libdir/%_name/v%version/drivers/

# install documentation
pushd %buildroot%_datadir/%name/v%{version}/docs/html
mv Beast-Quickstart Beast-Quickstart.html
sed -i \
	-e 's/Beast-Quickstart/Beast-Quickstart.html/' \
	beast-index.html
ln -s beast-index.html index.html
mkdir -p %buildroot%_docdir/lib%_name-devel-%version/html
mv * %buildroot%_docdir/lib%_name-devel-%version/html/
popd
mv docs/*.txt %buildroot%_docdir/lib%_name-devel-%version/

# fixes for repocop
mkdir -pv %buildroot%_liconsdir
mkdir -pv %buildroot%_miconsdir
mkdir -pv %buildroot%_niconsdir
ln -s %_datadir/pixmaps/%name.png %buildroot%_liconsdir/
convert %buildroot%_pixmapsdir/%name.png -resize "32x32" \
	%buildroot%_niconsdir/%name.png
convert %buildroot%_pixmapsdir/%name.png -resize "16x16" \
	%buildroot%_miconsdir/%name.png

for size in 16x16 32x32 48x48 ; do
	convert %buildroot%_pixmapsdir/beast-audio-x-bse.png -resize $size \
		%buildroot%_iconsdir/hicolor/$size/apps/beast-audio-x-bse.png
done
bzip2 ChangeLog

%find_lang --with-gnome --output=%name.lang %name-v%version %_name-v%version

%files -f %name.lang
%_bindir/*

%files common
%_desktopdir/*
%_datadir/application-registry/*
%_datadir/%name
%_datadir/%_name
%_pixmapsdir/*
%_liconsdir/*.png
%_miconsdir/*.png
%_niconsdir/*.png
%_datadir/mime-info/*
%_datadir/mime/packages/*
%_man1dir/*
%doc AUTHORS COPYING ChangeLog.bz2 NEWS README TODO 

%files -n lib%_name
%_libdir/*.so.*
%_libdir/%_name
%exclude %_libdir/%_name/v%version/drivers/*

%files -n lib%_name-devel
%_includedir/*
%_libdir/*.so
%_pkgconfigdir/*
%_man5dir/*

%files -n lib%_name-devel-doc
%doc %_docdir/lib%_name-devel-%version

%files -n lib%_name-drivers-alsa
%_libdir/%_name/v%version/drivers/%{_name}*device-alsa.so

%changelog
* Wed May 13 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 0.7.2-alt4.svn20090420.M50.1
- Port for Branch 5.0

* Tue May 12 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 0.7.2-alt5.svn20090420
- Rebuild with gcc4.4

* Tue Apr 28 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 0.7.2-alt4.svn20090420
- Remove dependence on libtool version

* Mon Apr 20 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 0.7.2-alt3.svn20090420
- New trunk
- Added links into libbse-drivers-alsa (ALT #19687)

* Sun Feb 08 2009 Eugeny A. Rostovtsev (REAL) <real@altlinux.org> 0.7.2-alt2.svn20090110
	- fix Exec= entry in desktop file
	- bzip2 ChangeLog
	- move architecture-independent data into noarch packages
	- convert beast-audio-x-bse.png for icons dirs

* Fri Jan 16 2009 Eugeny A. Rostovtsev (REAL) <real@altlinux.org> 0.7.2-alt1.svn20090110
- version 0.7.2 release alt1.svn20090110 (don't need bootstrap)

* Fri Jan 16 2009 Eugeny A. Rostovtsev (REAL) <real@altlinux.org> 0.7.2-alt1
- get up from orphaned
- bootstrap for version 0.7.2 (without BSE driver for ALSA)

* Mon Jan 17 2005 Yuri N. Sedunov <aris@altlinux.ru> 0.6.4-alt1
- 0.6.4

* Thu Jul 08 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.2-alt0.5
- 0.6.2

* Mon Mar 08 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.1-alt0.5
- 0.6.1

* Wed Feb 11 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.0-alt0.5
- 0.6.0

* Mon Dec 29 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.6-alt0.7
- 0.5.6

* Thu Dec 25 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.5-alt0.7
- do not package .la files.

* Wed Oct 29 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.5-alt0.6
- fix %%install

* Tue Oct 28 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.5-alt0.5
- 0.5.5

* Wed Oct 01 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.4-alt0.6
- fixed build with hasher.

* Tue Jul 22 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.4-alt0.5
- new version.

* Wed Jun 25 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.3-alt0.5
- new version.

* Sun Jun 22 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.2-alt0.5
- new version.
- menus and icon.
- summary, descriptions by avp.

* Wed Apr 16 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.5.1-alt0.5
- First build for Sisyphus.

